import javax.microedition.lcdui.*;
import java.util.*;

public class IndexList extends List implements CommandListener { 
    MapCanvas canvas;

    IndexList(MapCanvas canvas) { 
        super(Locale.INDEX, IMPLICIT);
        this.canvas = canvas;
        MobileMap map = canvas.main;
        for (int i = ObjectType.FIRST_OBJECT; i < ObjectType.LAST_OBJECT; i++) { 
            if (map.nObjects[i] != 0) { 
                append(Locale.OBJECT_TYPE[i], map.objectTypeIcons[i]);
            }
        }
        setCommandListener(this);
        addCommand(MobileMap.BACK_CMD);        
        Display.getDisplay(canvas.main).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d)  
    {
        if (c != MobileMap.BACK_CMD) { 
            int i =  getSelectedIndex();
            if (i >= 0) { 
                MobileMap map = canvas.main;
                for (int j = ObjectType.FIRST_OBJECT; j < ObjectType.LAST_OBJECT; j++) { 
                    if (map.nObjects[j] != 0) {
                        if (i == 0) { 
                            new CategoryList(canvas, this, j);
                            return;
                        }
                        i -= 1;
                    }
                }
            }
        }   
        Display.getDisplay(canvas.main).setCurrent(canvas);
    }
}    