import javax.microedition.lcdui.*;

public class InfoForm extends Form implements CommandListener { 
    MapCanvas canvas;
    Street    street;
    int       fx, fy;

    InfoForm(MapCanvas canvas, Street street, int fx, int fy) { 
        super(Locale.OBJECT_TYPE[street.type]);
        this.canvas = canvas;
        this.street = street;
        this.fx = fx;
        this.fy = fy;

        append(new ImageItem(null, canvas.main.objectTypeIcons[street.type], 
                             ImageItem.LAYOUT_CENTER|ImageItem.LAYOUT_NEWLINE_AFTER, null));
        append(street.name);
        
        if (canvas.main.crosses.length > 0) {  
            addCommand(MobileMap.START_POINT_CMD);
            addCommand(MobileMap.FINISH_POINT_CMD);
        }
        addCommand(MobileMap.BACK_CMD);
        setCommandListener(this);
        Display.getDisplay(canvas.main).setCurrent(this);
    }


    public void commandAction(Command c, Displayable d) 
    {
        if (c == MobileMap.START_POINT_CMD) {
            canvas.startPoint = canvas.searchNearestCross(fx, fy);
            canvas.route = null;
            if (canvas.startPoint == null) { 
                canvas.showError(Locale.NO_OBJECT);
                return;
            }       
        } else if (c == MobileMap.FINISH_POINT_CMD) {
            canvas.finishPoint = canvas.searchNearestCross(fx, fy);
            canvas.route = null;
            if (canvas.finishPoint == null) { 
                canvas.showError(Locale.NO_OBJECT);
                return;
            }       
        }
        Display.getDisplay(canvas.main).setCurrent(canvas);
    }
}
