import javax.microedition.lcdui.*;
import java.util.*;

public class RouteForm extends Form implements CommandListener { 
    MapCanvas canvas;
    
    static String twoDigits(int num) {
        String str = Integer.toString(num);
        if (str.length() == 1) { 
            return "0" + str;
        }
        return str;
    }

    static String getTime(int time) { 
        StringBuffer buf = new StringBuffer();
        if (time/3600 != 0) { 
            buf.append(twoDigits(time/3600));
            buf.append(':');
        }
        buf.append(twoDigits(time/60%60));
        buf.append(':');
        buf.append(twoDigits(time%60));
        return buf.toString();
    }        

    RouteForm(MapCanvas canvas, String title) { 
        super(title);
        this.canvas = canvas;
        append(new StringItem(Locale.TIME, getTime(canvas.route.time)));
        append(new StringItem(Locale.DISTANCE, Integer.toString(canvas.route.distance)));
        setCommandListener(this);
        addCommand(MobileMap.BACK_CMD);        
        addCommand(MobileMap.EXPLAIN_ROUTE_CMD);        
        Display.getDisplay(canvas.main).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d)  
    {
        if (c == MobileMap.EXPLAIN_ROUTE_CMD) { 
            new RouteList(canvas);
        } else { 
            Display.getDisplay(canvas.main).setCurrent(canvas);
        }
    }
}