import javax.microedition.lcdui.*;
import java.util.*;

public class RouteList extends List implements CommandListener { 
    MapCanvas canvas;

    RouteList(MapCanvas canvas) { 
        super(Locale.EXPLAIN_ROUTE, IMPLICIT);
        this.canvas = canvas;
        Edge[] e = canvas.route.edges;
        Street[] streets = canvas.main.streets;
        String prevName = null;
        for (int i = 0; i < e.length; i++) { 
            String name = streets[e[i].segment.streetIndex].name;
            if (!name.equals(prevName)) { 
                append(name, null);
            }
            prevName = name;
        }
        setCommandListener(this);
        addCommand(MobileMap.BACK_CMD);        
        Display.getDisplay(canvas.main).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d)  
    {
        if (c != MobileMap.BACK_CMD) { 
            int j = getSelectedIndex();
            if (j >= 0) { 
                Edge[] e = canvas.route.edges;
                Street[] streets = canvas.main.streets;
                String prevName = null;
                int i;
                for (i = 0; j != 0; i++) { 
                    String name = streets[e[i].segment.streetIndex].name;
                    if (!name.equals(prevName)) { 
                        j -= 1;
                    }
                    prevName = name;
                }
                canvas.selectStreet(canvas.route.edges[i].segment.streetIndex);                
            }
        }
        Display.getDisplay(canvas.main).setCurrent(canvas);
    }
}