import javax.microedition.lcdui.*;

public class SearchBox extends TextBox implements CommandListener
{ 
    MapCanvas   canvas;

    static final int MAX_ALTERNATIVES = 10;

    SearchBox(MapCanvas canvas) { 
        super(Locale.SEARCH_PATTERN, "", 256, TextField.ANY);       
        this.canvas = canvas;
        setCommandListener(this);
        addCommand(MobileMap.SEARCH_CMD);
        addCommand(MobileMap.BACK_CMD);
        Display.getDisplay(canvas.main).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {    
        if (c == MobileMap.SEARCH_CMD) {
            String prefix = getString();
            int index = canvas.main.findStreet(prefix.toLowerCase());
            Street[] streets = canvas.main.streets;
            boolean matched = false;
            int i;
            for (i = index; i < streets.length; i++) { 
                if (streets[i].name.startsWith(prefix)) { 
                    matched = true;
                } else if (matched || i-index >= MAX_ALTERNATIVES) { 
                    break;
                }
            }                    
            new StreetList(canvas, index, i);
        } else { 
            Display.getDisplay(canvas.main).setCurrent(canvas);
        }
    }
}
    
